----------------------------------------------------------------------------------
-- Company: 
-- Engineer: 
-- 
-- Create Date:    12:00:14 09/25/2009 
-- Design Name: 
-- Module Name:    LEDDRV - Behavioral 
-- Project Name: 
-- Target Devices: 
-- Tool versions: 
-- Description: 
--
-- Dependencies: 
--
-- Revision: 
-- Revision 0.01 - File Created
-- Additional Comments: 
--
----------------------------------------------------------------------------------
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;

---- Uncomment the following library declaration if instantiating
---- any Xilinx primitives in this code.
--library UNISIM;
--use UNISIM.VComponents.all;

entity LEDDRV is
    Port ( clk : in  STD_LOGIC;
           s : in  STD_LOGIC;
           q : out  STD_LOGIC);
end LEDDRV;

architecture Behavioral of LEDDRV is
signal cnt : std_logic_vector(23 downto 0) := x"000000";
signal iq : std_logic;

constant LEDWID : std_logic_vector(23 downto 0) := conv_std_logic_vector(2500000, 24);
begin


q <= iq;

  process(clk)
  begin
  if(clk'event and clk = '1') then
    if(s = '1') then
      iq <= '1';
    elsif(iq = '1') then
      if(cnt = LEDWID) then
        cnt <= LEDWID;
        iq <= '0';
      else
        cnt <= cnt + '1';
        iq <= '1';
      end if;
    else
      cnt <= x"000001";
      iq <= '0';
    end if;
  end if;
  end process;

end Behavioral;

